/* raptor - fast port scanner
 * CNS/minithins is against all politics.
 * CNS/minithins is not french, it is internationnal
 * CNS/minithins is the best.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <netdb.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <net/if.h>
#include <sys/ioctl.h>

#include <signal.h>
#include <errno.h>
#ifdef USE_THREAD
#include <pthread.h>
#endif
#include <pcap.h>

#ifndef __USE_BSD
#define __USE_BSD
#endif

#ifndef __FAVOR_BSD
#define __FAVOR_BSD
#endif 
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>

#define IP_SIZE sizeof(struct ip)
#define TCP_SIZE sizeof(struct tcphdr)

#define SERVICE_TABLE_SIZE 8192 
#define LATENCY_TIME 100000
#define LATENCY_SEND 4 

struct pseudo_header
{
  u_int32_t s_addr;
  u_int32_t d_addr;
  u_int8_t  zero;
  u_int8_t  protocol;
  u_int16_t length;
};

struct scan_stats
{
  unsigned int recieved_packets;
  unsigned int sent_packets;
  unsigned int open_ports;
  unsigned int close_ports;
} my_scan_stats;

typedef struct datalink_type
{
  char name[32];
  int  lenght;
} datalink_data;

struct my_packet
{
  struct my_packet *next; 
  uint32_t host; 
  uint16_t s_port;
  uint16_t d_port; 
  uint32_t seq;
  int number;
} *head_sent = NULL, *head_answ = NULL, *head_firewl = NULL;

struct rts_packet
{
  u_char *buffer;
  int   size;
  int   flags;
  struct sockaddr_in n;
  struct my_packet *m;
};

const datalink_data datalink_main[] = 
{
  { "no link-layer encapsulation", 4 },
  { "Ethernet (10Mb)", 14 },
  { "Experimental Ethernet (3Mb)", 14 },
  { "Amateur Radio AX.25", 0 },            /* A REMPLIR */
  { "Proteon ProNET Token Ring", 0 },      /* A REMPLIR */
  { "Chaos", 0 },                          /* A REMPLIR */
  { "IEEE 802 Networks", 0 },              /* A REMPLIR */
  { "ARCNET", 0 },                         /* A REMPLIR */
  { "Serial Line IP", 16 },
  { "Point-to-point Protocol", 4 },
  { "FDDI", 21 },
  { "LLC/SNAP encapsulated atm", 0 },      /* A REMPLIR */
  { "raw IP", 0 },
  { "BSD/OS Serial Line IP", 16 },          /* should be ok... */
  { "BSD/OS Point-to-point Protocol", 4 },  /* should be ok... */ 
  { "napu", 0}
};

int link_len, link_type;
unsigned short service_table[SERVICE_TABLE_SIZE];
unsigned short service_number;
uint32_t ip_src;
uint32_t ip_dst;
unsigned short initial_id;
struct in_addr dest, ldest, ip_dsts, netmask;
unsigned short actual_machine_port;
int new_machine = 0;
int mask;

#ifdef USE_THREAD
pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;
pthread_t thread1;
unsigned int level = 0;
#endif

int rand_seed ()
{
  char *name = "/dev/urandom";
  unsigned int tmp, n;
  
  n = open (name, O_RDONLY);
  read (n, &tmp, 4);
  close (n);
  return (tmp);
}

int read_services (char *nameg)
{
  char *name = "/etc/services";
  char line[1024], *p;
  FILE *fp;
  char servicename[256];
  unsigned short port;
  char proto[32];
  int i = 0;

  bzero (service_table, sizeof(unsigned short) * SERVICE_TABLE_SIZE);

  if (nameg)
  {
    name = malloc(strlen(nameg));
    strcpy(name, nameg);
  }

  fp = fopen(name, "r");
  if (!fp)
    exit (1);

  while (fgets(line, sizeof(line), fp))
  {
    p = line;
    while (*p && isspace ((int) *p))
      p ++;

    if (*p == '#')
      continue;

    if (sscanf (line, "%s %hu/%s", servicename, &port, proto) == 3)
    {
      if (!strncmp(proto, "tcp", 3))
      {
        if (i == SERVICE_TABLE_SIZE)
          printf("please increase SERVICE_TABLE_SIZE\n"), exit (-1);
        service_table[i] = port;
        i ++;
      }
    }
  }
  printf("nombre d'enc. %i\n", i);
  return i;
}

int show_stats ()
{
  printf("\n");
  printf("Send packets:    %i\n", my_scan_stats.sent_packets);
  printf("Open ports:      %i\n", my_scan_stats.open_ports);
  printf("Closed ports:    %i\n", my_scan_stats.close_ports);
  printf("Fw/ N/A packets: %i\n",
    my_scan_stats.sent_packets - my_scan_stats.open_ports
     - my_scan_stats.close_ports);

  return (0);
}

void get_signal (int signal)
{
  printf("GOT SIGNAL %i\n", signal);
  show_stats();
  exit (0);
}

uint32_t resolv(char *hostname)
{
  struct in_addr in;
  struct hostent *hp;

  if ((in.s_addr = inet_addr(hostname)) == -1)
  {
    if ((hp = gethostbyname(hostname)))
      bcopy(hp->h_addr, &in.s_addr, hp->h_length);
    else
    {
      printf("Can't resolv hostname ?!\n");
      exit(-1);
    }
  }
  return in.s_addr;
}

uint32_t getmyipaddr (uint32_t destination)
{
  int fd, socklen;
  struct sockaddr_in sa;

  fd = socket (AF_INET, SOCK_DGRAM, 0);
  sa.sin_family = AF_INET;
  sa.sin_port = htons(rand() % 65536);
  sa.sin_addr.s_addr = destination;

  connect(fd, (struct sockaddr *)&sa, sizeof(struct sockaddr_in));
//  perror ("connect");

  socklen = sizeof(struct sockaddr);
  getsockname (fd, (struct sockaddr *)&sa, &socklen);
//  perror ("getsockname");

  close (fd);

  if ((sa.sin_addr.s_addr & 0x7F) == 0x7F)
    sa.sin_addr.s_addr = 0x0100007F; 
//    sa.sin_addr.s_addr = destination;

  return (sa.sin_addr.s_addr);
}

char *getmynetif (uint32_t ip)
{
  int m_sock, i;
  int lastlen = 0;
  int len;
  struct ifconf ifc;
  struct ifreq *ifr;
  char *buf, *ptr;
  struct sockaddr_in *temp;

  m_sock = socket (AF_INET, SOCK_STREAM, 0);

  len = 100 * sizeof(struct ifreq);

  for (i=0;;i++)
  {
    buf = (char*)malloc(len);
    ifc.ifc_len = len;
    ifc.ifc_buf = buf;

    if (ioctl (m_sock, SIOCGIFCONF, &ifc) < 0)
      perror("ioctl::SIOCGIFCONF"), exit(EXIT_FAILURE);
    else
    { 
      if (ifc.ifc_len == lastlen)
        break;
      lastlen = ifc.ifc_len; 
    }
    len += 10 * sizeof(struct ifreq);
    free (buf);
  }

  for (ptr = buf ; ptr < buf + ifc.ifc_len ; )
  {
    ifr = (struct ifreq *)ptr;

    switch (ifr->ifr_addr.sa_family) 
    {
      case AF_INET:
      default:
        len = sizeof(struct sockaddr);
      break;
    }

    ptr += sizeof(ifr->ifr_name) + len;

    if (ifr->ifr_addr.sa_family != AF_INET) 
      continue;

    switch (ifr->ifr_addr.sa_family) 
    {
      case AF_INET: 
      break;
      default:
        printf("famille: aucune connue (%i)\n", ifr->ifr_addr.sa_family);
      break;
    }

    temp = (struct sockaddr_in*)&ifr->ifr_addr;

    if (temp->sin_addr.s_addr == ip)
      return (ifr->ifr_ifrn.ifrn_name);
  }

  return (NULL);
}

unsigned short in_cksum (u_short *addr, int len)
{
  register int nleft = len;
  register u_short *w = addr;
  register int sum = 0;
  u_short answer = 0;

  while (nleft > 1)  
  {    
    sum += *w++; 
    nleft -= 2;
  }
  
  if (nleft == 1)
  {
    *(u_char *) (&answer) = *(u_char *) w;
    sum += answer; 
  }
  
  sum = (sum >> 16) + (sum & 0xffff);   
  sum += (sum >> 16);           
  answer = ~sum;                    
  return (answer);
}               

struct rts_packet *build_packet (int port)
{
  u_char *my_packet = NULL;
  struct ip *ip_hdr = NULL;
  struct tcphdr *tcp_hdr = NULL;
  struct sockaddr_in my_sock_param;
  struct my_packet *tmp_my_packet;
  struct pseudo_header *temp_crc;
  struct rts_packet *rtn = malloc (sizeof(struct rts_packet));

  my_packet = (u_char *)malloc(IP_SIZE + TCP_SIZE);
  ip_hdr  = (struct ip*)my_packet;
  tcp_hdr = (struct tcphdr*)(my_packet + IP_SIZE);

  temp_crc = (struct pseudo_header *)(my_packet + IP_SIZE - sizeof(struct pseudo_header));

  bzero (my_packet, IP_SIZE + TCP_SIZE);

  ip_dst = dest.s_addr;

  tcp_hdr->th_sport = (((initial_id + port) % 65536) < 1024)?
    (((initial_id + port) % 65536) + 1024):(initial_id + port); 
  tcp_hdr->th_dport = htons (port);
  tcp_hdr->th_seq   = rand();
  tcp_hdr->th_ack   = 0x0;
  tcp_hdr->th_x2    = 0x00;
  tcp_hdr->th_off   = 0x05;
  tcp_hdr->th_flags = TH_SYN;
  tcp_hdr->th_win   = htons (1024);
  tcp_hdr->th_sum   = 0x00;
  tcp_hdr->th_urp   = 0x00;

  temp_crc->s_addr = ip_src;
  temp_crc->d_addr = ip_dst;

  temp_crc->zero     = 0;
  temp_crc->protocol = 6;
  temp_crc->length   = htons(TCP_SIZE);

  tcp_hdr->th_sum = in_cksum((unsigned short *)temp_crc,
    sizeof (struct pseudo_header) + TCP_SIZE);

  ip_hdr->ip_hl  = 5;
  ip_hdr->ip_v   = 4;
  ip_hdr->ip_tos = 0x10;
  ip_hdr->ip_len = htons(IP_SIZE + TCP_SIZE);
  ip_hdr->ip_id  = 0x1234;
  ip_hdr->ip_off = htons(0x4000);
  ip_hdr->ip_ttl = 64;
  ip_hdr->ip_p   = IPPROTO_TCP;
  ip_hdr->ip_sum = in_cksum((unsigned short *)ip_hdr, IP_SIZE);
  ip_hdr->ip_src.s_addr = ip_src;
  ip_hdr->ip_dst.s_addr = ip_dst;

  my_sock_param.sin_family = AF_INET;
  my_sock_param.sin_port = htons (port);
  my_sock_param.sin_addr.s_addr = ip_dst;

  rtn->n       = my_sock_param;
  rtn->buffer  = my_packet;
  rtn->size    = IP_SIZE + TCP_SIZE;
  rtn->flags   = 0;

  for (tmp_my_packet = head_sent; tmp_my_packet; 
    tmp_my_packet = tmp_my_packet->next)
  {
    if (tmp_my_packet->host == ip_dst 
        && tmp_my_packet->d_port == port)
      break;
  }

  if (!tmp_my_packet)
  {
    /* create #!@ */
    if ((tmp_my_packet = (struct my_packet *)malloc(sizeof(struct my_packet))))
    {
      tmp_my_packet->next = head_sent;
      tmp_my_packet->host = ip_dst;
      tmp_my_packet->s_port = tcp_hdr->th_sport;
      tmp_my_packet->d_port = port;
      tmp_my_packet->seq = tcp_hdr->th_seq;
      tmp_my_packet->number = 0;
      head_sent = tmp_my_packet;
    } else {
      printf("MEMORY LEAK :(\n");
    }
  }

  rtn->m = tmp_my_packet;

  return (rtn);
}

/** multi-host scanning functions **/

int get_next_host(void)
{
  unsigned char tmp;

  dest.s_addr = ntohl(dest.s_addr);
  again:

  if (dest.s_addr == ntohl(ldest.s_addr))
  {
    dest.s_addr = htonl(dest.s_addr);
    return(1);
  }

  dest.s_addr ++;
  tmp = (unsigned char) (dest.s_addr & 0x000000ff);

  if (tmp == 0 || tmp == 255)
    goto again;

  dest.s_addr = htonl(dest.s_addr);
  new_machine = 1;
  return(0);
}

int parse_host(char *hostname)
{
  char *ptr;

  if ((ptr = strchr(hostname, '/')))
    *ptr = 0;

  dest.s_addr = resolv(hostname);
  if (ptr == NULL)
  {
    ldest = dest;
    mask = 32;
  } 
  else 
  {
    mask = atoi(ptr+1);     
    if (!(mask > 0 && mask < 32))
    {
      ldest = dest;
      mask = 32;
      return(0);
    }

    dest.s_addr = ntohl(dest.s_addr);
    ldest.s_addr = dest.s_addr;
    dest.s_addr &= ~(u_int32_t) ((2 << (31 - mask)) - 1);
    ldest.s_addr |= (u_int32_t) ((2 << (31 - mask)) - 1);
    if (((unsigned char) (dest.s_addr & 0x000000ff) == 0) ||
      ((unsigned char) (dest.s_addr & 0x000000ff) == 255))
      dest.s_addr ++;
    dest.s_addr = htonl(dest.s_addr);
    ldest.s_addr = htonl(ldest.s_addr);
    }
  return(0);
}

unsigned int get_mask (unsigned int n, int mmask)
{
  int i;
  unsigned int net = 0xffffffff;
  unsigned int mynet = htonl (n);

  for (i = 32; mmask < i; i --)
    net = (net << 1);

  netmask.s_addr = htonl(net);

  return (htonl(mynet & net));
}

/** end of multi-host scanning functions **/

int send_packet (int l_socket, struct rts_packet *m)
{
  int one = 1;
  const int *val = &one;
  struct my_packet *tmp, *o_tmp;
  
  setsockopt (l_socket, IPPROTO_IP, IP_HDRINCL, val, sizeof(one));
  sendto (l_socket, m->buffer, m->size, m->flags, (struct sockaddr*)&m->n, sizeof (m->n)); 
  m->m->number ++;

  if (m->m->number == 2)
  {
    // too much try on the same packet, we move it to firewall'ed area.
#ifdef USE_THREAD
      pthread_mutex_lock(&mutex1);
#endif
      tmp = head_sent;
      o_tmp = NULL;
      while (tmp)
      {
        if (tmp == m->m)
        {
          if (o_tmp)
            o_tmp->next = tmp->next;
          else
          {
            if (head_sent) 
              head_sent = head_sent->next;
          }
          tmp->next = head_firewl;
          head_firewl = tmp;
          break;
        }
        o_tmp = tmp;
        tmp = tmp->next;
      }
#ifdef USE_THREAD
      pthread_mutex_unlock(&mutex1);
#endif
  }

  return 0;
}

int parse_packet (u_char *packet)
{
  struct ip *ip_hdr; 
  struct tcphdr *tcp_hdr;
  struct my_packet *tmp, *o_tmp;

  if (!packet)
    return -1;

  ip_hdr = (struct ip*)(packet + link_len);

  if (ip_hdr->ip_v == 4 && ip_hdr->ip_p == IPPROTO_TCP)
  {
    tcp_hdr = (struct tcphdr *)(packet + link_len + IP_SIZE);

// broken
    if (ip_hdr->ip_src.s_addr == ip_dst)
      my_scan_stats.recieved_packets ++;

// broken too
    if ((tcp_hdr->th_flags == (TH_SYN | TH_ACK)) 
      && ((ip_hdr->ip_src.s_addr & netmask.s_addr) == ip_dsts.s_addr))
    {
      printf("%s:%i - OPENED\n", 
        inet_ntoa(ip_hdr->ip_src), htons(tcp_hdr->th_sport));
      my_scan_stats.open_ports ++;

      /* we toggle entry to the next */
#ifdef USE_THREAD
      pthread_mutex_lock(&mutex1);
#endif
      for (tmp = head_sent, o_tmp = NULL; tmp; o_tmp = tmp, tmp = tmp->next)
      {
        if (htonl(tmp->seq) + 1 == htonl(tcp_hdr->th_ack))
        {
          if (o_tmp)
            o_tmp->next = tmp->next;
          else
            head_sent = head_sent->next;

          tmp->next = head_answ;
          head_answ = tmp;

          break;
        }
      }
#ifdef USE_THREAD
      pthread_mutex_unlock(&mutex1);
#endif
    } 

    if ((tcp_hdr->th_flags == (TH_RST | TH_ACK))
      && ip_hdr->ip_src.s_addr == ip_dst)
    {
      my_scan_stats.close_ports ++ ;

      /* we remove entry of the head_sent list */  
#ifdef USE_THREAD
      pthread_mutex_lock(&mutex1);
#endif
      tmp = head_sent;
      o_tmp = NULL;
      while (tmp)
      {
        if (htonl(tmp->seq) + 1 == htonl(tcp_hdr->th_ack))
        {
          if (o_tmp)
            o_tmp->next = tmp->next;
          else
          {
            if (head_sent)
              head_sent = head_sent->next;
          }
          free (tmp);
          break;
        }
        o_tmp = tmp;
        tmp = tmp->next;
      }
#ifdef USE_THREAD
      pthread_mutex_unlock(&mutex1);
#endif
    }
  }
  else
    return (-1);

  return 0;
}

unsigned short get_next_port_to_scan ()
{
  // on va scanner les 1024 1ers ports d'une machine.
  if (new_machine)
  { 
    new_machine = 0;
    actual_machine_port = 0;
  }
  if (service_table[actual_machine_port])
    return (service_table[actual_machine_port]);
  else
  { 
    // quand on arrive  1024, on change de machine
    if (head_sent == NULL)
      return 0;
    else
      return (head_sent->d_port);
  }
}

int main (int argc, char **argv, char **envp)
{
  int raw_socket, tmp, ret, pas_fini;
  struct pcap *raw_listener;
  struct pcap_pkthdr datas;
  char errbuf[PCAP_ERRBUF_SIZE];
  unsigned char *packet;
  char *pcap_filter, *pcap_filter_addr;
  char *device;
  int step, tout_envoye = 0;
  unsigned short cur_port;

  struct bpf_program fcode;
  bpf_u_int32 localnet, netmask;

  fd_set save, current;
  struct timeval ts;

  //struct my_packet *mtmp;

  struct sigaction myend;

  myend.sa_handler = (void*)get_signal;
  myend.sa_flags = 0 ;
  sigaction(SIGINT,&myend,NULL);

//  pthread_mutex_init (mutex1, )

  my_scan_stats.recieved_packets = 0;
  my_scan_stats.sent_packets = 0;

  srand (rand_seed());

  printf("CNS/raptor - port scanner\n");
  printf("MY DJ LEADS MY NIGHT #!@#!@\n");
  printf("Check lame stuff at http://www.minithins.net/releases/\n\n");

  if (getuid ())
    printf("need uid = 0\n"), exit (EXIT_FAILURE);

  /* source and destination ips are managed here ... */

  if (argc == 1)
    printf("%s -opts- <ip>\n", argv[0]), exit (EXIT_FAILURE);

  pcap_filter_addr = (char*)malloc((strlen(argv[1]) + 1) * sizeof(char));
  strncpy(pcap_filter_addr, argv[1], strlen(argv[1]));
  pcap_filter_addr[strlen(argv[1])] = 0;
  parse_host(argv[1]);

//  ip_dst = resolv (argv[1]); 
//  printf("Detect 1st host to scan: %s\n", inet_ntoa(dest));
  ip_src = getmyipaddr(dest.s_addr);
  ip_dst = dest.s_addr;

  if (!(device = getmynetif(ip_src)))
    exit (EXIT_FAILURE);

  initial_id = rand();
  printf("initial value sets to %i\n", initial_id);

  service_number = read_services("./services");
  printf("services in mem: %i\n", service_number);

  raw_socket = socket (AF_INET, SOCK_RAW, IPPROTO_TCP);

  raw_listener = pcap_open_live (device, 1524, 1, 0, errbuf);

  if (pcap_lookupnet(device, &localnet, &netmask, NULL) < 0)
    perror("pcap_lookupnet");

  pcap_filter = (char *)malloc(sizeof(char) * 256);

  ip_dsts.s_addr = get_mask(dest.s_addr, mask);

  sprintf(pcap_filter, "src net %s/%i and (tcp[13] != 2) and (tcp[13] != 4) and not arp", inet_ntoa(ip_dsts), mask);

  printf("filtre appliqu: %s\n", pcap_filter);

  if (pcap_compile(raw_listener, &fcode, pcap_filter, 1, localnet) < 0)
    perror("pcap_compile");

  if (pcap_setfilter(raw_listener, &fcode) < 0)
    perror("pcap_setfilter");

  link_type = pcap_datalink(raw_listener);
  link_len  = datalink_main[link_type].lenght;
  printf("Link layer type: %s\n", datalink_main[link_type].name);

  FD_ZERO(&current);
  memcpy (&tmp, raw_listener, 4);
  FD_SET(tmp, &current);
  save = current;

  step = 0;

  ts.tv_sec = 0;
  ts.tv_usec = LATENCY_TIME;
  
  pas_fini = -1000;

  while (pas_fini)
  {
    current = save;
    ret = select (tmp + 1, &current, NULL, NULL, &ts); 

    if (ret)
    {
      if ((packet = (char*)pcap_next (raw_listener, &datas)))
      {
#ifdef USE_THREAD
        pthread_create(&thread1, NULL, (void*)&parse_packet, packet);
#else
        parse_packet(packet);
#endif
      }
    }
    else
    {
      step ++;
// si le nombre envoy de paquets est != le nombre de port  scanner
// == si le scan n'est pas fini
      if ((cur_port = get_next_port_to_scan ()))
      {
        if (step == LATENCY_SEND)
        {
          usleep (LATENCY_TIME);
          step = 0;
        }
        send_packet(raw_socket, build_packet (cur_port));
        actual_machine_port ++;
        my_scan_stats.sent_packets ++;
      }
      else
      {
        // printf("actual host: %.8x (%i)\n", dest, tout_envoye);
        if (get_next_host ())
          tout_envoye = 1;
        else
        {
          if ((dest.s_addr & 0xFF) == 0xFF)
            ip_src = getmyipaddr(dest.s_addr);
//          printf("ip source: %8x\n", ip_src);
        }
      }
    }

    if (tout_envoye)
    {
      usleep (LATENCY_TIME);

//      if (my_scan_stats.recieved_packets == (service_number * nombre_machine))
//        pas_fini = 0;
//      else
      pas_fini ++;
    }
  }
  close (raw_socket);
  pcap_close (raw_listener);

/*
  printf("no answer:\n\n");
  for (mtmp = head_sent; mtmp; mtmp = mtmp->next)
  {
    printf("to %4x:%i (from port %i) lost ? firewalled ?\n",
      mtmp->host, mtmp->d_port, mtmp->s_port);
  }
*/
//  printf("\nfirewalled:\n\n");
/*
  for (mtmp = head_firewl; mtmp; mtmp = mtmp->next)
  {
    printf("to %4x:%i (from port %i) lost ? firewalled ?\n",
      mtmp->host, mtmp->d_port, mtmp->s_port);
  }
*/
  if (pcap_filter)
    free (pcap_filter);

  show_stats ();

  return 0;
}
